unit Distance;     //metrika

interface

uses
  Simulator;

type
  TDist = double;
  TDistance = class (TObject)
  private
    fA: double;
  public
    procedure SetA(aA:double);
    function Distance(aq1,aq2:vector_q):TDist;
    property A:double read fA write fA;
  end;

implementation

{ TDistance }

procedure TDistance.SetA(aA:double);
begin
  fA:=aA;
end;

function TDistance.Distance(aq1, aq2: vector_q):TDist;
  var deltaTheta: double;
begin
	deltaTheta:= aq1.theta-aq2.theta;
	if (deltaTheta > PI) then
		deltaTheta:= deltaTheta-2*PI
	else if (deltaTheta < -PI) then
		deltaTheta:= deltaTheta +2*PI;
  result:=sqrt( sqr(aq1.x-aq2.x) + sqr(aq1.y-aq2.y) + sqr(deltaTheta)*fA );
end;


end.

