unit Polygon;

interface

uses                              
  Classes;

type
  vertex = record
    x: double;
    y: double;
  end;
  TVertex = class (TObject)   
  private
    Fx,Fy: double;
  public
    procedure Move(ax,ay:double);     //posun bodu ve smeru x a y
    procedure Rotate(angle:double);   //rotace bodu kolem osy z
    property x:double read Fx write Fx;
    property y:double read Fy write Fy;
  end;
  TVert = record
    x,y: integer;
  end;

  TVertices = TList;      

  TPolygon = class (TObject)
  private
    FVertices:TVertices;      //seznam vrchol polygonu
  public
    constructor Create;
    destructor Destroy;override;
    procedure AddVertex(aV:TVertex);      //pidn vrcholu do seznamu
    procedure Clean;
    function VertexCount:integer;          //vraci pocet vrcholu polygonu
    property Vertices:TVertices read FVertices write FVertices;
  end;

implementation

{ TVertex }

  // Posun bodu ve smerech x a y	
procedure TVertex.Move(ax, ay: double);
begin
  Fx:=Fx+ax;
  Fy:=Fy+ay;
end;

  // Rotace bodu okolo osy z
procedure TVertex.Rotate(angle: double);
var old_x,old_y: double;
begin
  old_x:=Fx;
  old_y:=Fy;
  Fx:=old_x*cos(angle)+old_y*sin(angle);
  Fy:=old_x*(-sin(angle))+old_y*cos(angle);
end;

{ TPolygon }

procedure TPolygon.AddVertex(aV: TVertex);
begin
  FVertices.Add(aV);
end;

procedure TPolygon.Clean;
var i:integer;
begin
  for i:=0 to FVertices.Count-1 do TObject(FVertices.Items[i]).Free;
     FVertices.Clear;
end;

function TPolygon.VertexCount;
begin
  result:=FVertices.Count;
end;

constructor TPolygon.Create;
begin
  inherited create;
  FVertices:=TList.Create;
end;

destructor TPolygon.Destroy;
begin
  Clean;
  inherited destroy;
end;

end.

